package br.com.tcc.safeson.safeson;

import android.Manifest;
import android.app.Dialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.location.Location;
import android.location.LocationManager;
import android.location.LocationListener;
import android.os.BatteryManager;
import android.os.Bundle;
import android.os.Handler;
import android.support.annotation.NonNull;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AlertDialog;
import android.view.View;
import android.support.design.widget.NavigationView;
import android.support.v4.view.GravityCompat;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.WindowManager;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.auth.api.Auth;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.location.places.Places;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.LatLngBounds;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.maps.GeoApiContext;
import com.google.maps.android.PolyUtil;
import com.google.maps.model.TravelMode;
import com.squareup.picasso.Picasso;

import java.util.Date;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;
import java.util.stream.Stream;

import br.com.tcc.safeson.safeson.actions.BaseMessage;
import br.com.tcc.safeson.safeson.actions.EventAlert.EventAlertAddMessage;
import br.com.tcc.safeson.safeson.actions.EventAlert.EventAlertGetResult;
import br.com.tcc.safeson.safeson.actions.EventFriends.EventFriendGetMessage;
import br.com.tcc.safeson.safeson.actions.EventFriends.EventFriendGetResult;
import br.com.tcc.safeson.safeson.actions.EventGroup.EventGroupGetMessage;
import br.com.tcc.safeson.safeson.actions.EventGroup.EventGroupGetResult;
import br.com.tcc.safeson.safeson.actions.EventInvite.EventInviteRespondMessage;
import br.com.tcc.safeson.safeson.actions.EventRoute.EventBroadcastCoordinatesMessage;
import br.com.tcc.safeson.safeson.actions.EventRoute.EventRouteFinishMessage;
import br.com.tcc.safeson.safeson.actions.EventRoute.EventRouteGetWatchingMessage;
import br.com.tcc.safeson.safeson.actions.EventRoute.EventRouteGetWatchingResult;
import br.com.tcc.safeson.safeson.actions.EventRoute.EventVerifyUserOnRouteMessage;
import br.com.tcc.safeson.safeson.activity.AboutActivity;
import br.com.tcc.safeson.safeson.activity.FriendsActivity;
import br.com.tcc.safeson.safeson.activity.GroupsActivity;
import br.com.tcc.safeson.safeson.activity.NotificationsActivity;
import br.com.tcc.safeson.safeson.components.ActivitiesComponents;
import br.com.tcc.safeson.safeson.components.DeviceComponents;
import br.com.tcc.safeson.safeson.components.LogoutComponents;
import br.com.tcc.safeson.safeson.components.MapComponents;
import br.com.tcc.safeson.safeson.components.RouteComponents;
import br.com.tcc.safeson.safeson.login.UserLogged;
import br.com.tcc.safeson.safeson.models.Alert;
import br.com.tcc.safeson.safeson.models.Convite;
import br.com.tcc.safeson.safeson.models.Coordenada;
import br.com.tcc.safeson.safeson.models.Grupo;
import br.com.tcc.safeson.safeson.models.PlaceInfo;
import br.com.tcc.safeson.safeson.models.PolylineData;
import br.com.tcc.safeson.safeson.models.TipoTrajeto;
import br.com.tcc.safeson.safeson.models.Trajeto;
import br.com.tcc.safeson.safeson.models.User;
import br.com.tcc.safeson.safeson.route.RouteEventsListener;
import br.com.tcc.safeson.safeson.service.PanicoService;
import br.com.tcc.safeson.safeson.socket.BroadcastEvent;
import br.com.tcc.safeson.safeson.socket.ResultObject;
import br.com.tcc.safeson.safeson.socket.SocketConnection;

import br.com.tcc.safeson.safeson.components.CameraComponents;

import br.com.tcc.safeson.safeson.util.ConvertDateFormatUtil;
import br.com.tcc.safeson.safeson.util.MaskEditUtil;
import br.com.tcc.safeson.safeson.util.ValidateTimeUtil;
import butterknife.BindView;
import butterknife.ButterKnife;
import de.hdodenhof.circleimageview.CircleImageView;
import in.goodiebag.carouselpicker.CarouselPicker;
import io.reactivex.Observable;
import io.reactivex.schedulers.Schedulers;

public class MainActivity extends AppCompatActivity
        implements NavigationView.OnNavigationItemSelectedListener, OnMapReadyCallback, GoogleApiClient.OnConnectionFailedListener, GoogleMap.OnMyLocationChangeListener {
    private static final String TAG_HOME = "map";
    private static final String TAG_FRINEDS = "amigos";
    private static final String TAG_GROUPS = "grupos";
    private static final String TAG_NOTIFICATIONS = "notificações";
    private static final String TAG_SETTINGS = "configuraçoes";
    private static final String TAG_ABOUT = "sobre";
    private static final String TAG_REPORTS = "acontecimentos";
    private static final String TAG_EXIT = "sair";
    public static String CURRENT_TAG = TAG_HOME;
    final String[] tipos = {"Dirigindo", "Bicicleta", "Onibus", "Andando"};

    private static final String TAG = "MapsActivity";
    private static final LatLngBounds LAT_LNG_BOUNDS = new LatLngBounds(new LatLng(-40, -168), new LatLng(71, 136));
    private static final String FINE_LOCATION = Manifest.permission.ACCESS_FINE_LOCATION;
    private static final String COURSE_LOCATION = Manifest.permission.ACCESS_COARSE_LOCATION;
    private static final int LOCATION_PERMISSION_REQUEST_CODE = 1234;
    public static final float DEFAULT_ZOOM = 15f;

    private GoogleMap mMap;

    private Boolean mapPermissionGranted = false;
    private GoogleApiClient googleApiClient;
    private GeoApiContext mapGeoApiContext = null;
    private PlaceInfo mapPlace;
    private ArrayList<PolylineData> mapPolylineData = new ArrayList<>();

    private MapComponents mapComponents;

    private CameraComponents cameraComponents;
    private RouteComponents routeComponents;

    private LocationManager locManager;
    private LocationListener locListener;

    private NavigationView navigationView;
    private DrawerLayout drawer;
    private View headerView;
    private Toolbar toolbar;

    private SocketConnection socket = SocketConnection.main;
    private SocketConnection routeSocket;
    private ArrayList<RouteEventsListener> routeEvents = new ArrayList<>();

    private Handler mHandler;
    private DeviceComponents deviceComponents;
    private Marker mapMarker;
    private Dialog dialog;
    private CarouselPicker carouselPicker1;

    private ArrayList<User> friends;
    private ArrayList<Grupo> groups;

    public static TipoTrajeto tipoTrajeto;

    private boolean leftPath = false;
    private FloatingActionButton cancelRouteBtn;

    // Broadcast events
    private BroadcastEvent alertAdd;
    private BroadcastEvent routeInvites;
    private BroadcastEvent routeFinish;

    AutoCompleteTextView mapSearchText;

    @BindView(R.id.ic_gps)
    ImageView mGps;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        final IntentFilter filter = new IntentFilter(Intent.ACTION_SCREEN_ON);
        filter.addAction(Intent.ACTION_SCREEN_OFF);
        final BroadcastReceiver mReceiver = new PanicoService();
        registerReceiver(mReceiver, filter);

        ButterKnife.bind(this);
        toolbar = findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);
        mHandler = new Handler();
        drawer = findViewById(R.id.drawer_layout);
        ActionBarDrawerToggle toggle = new ActionBarDrawerToggle(
                this, drawer, toolbar, R.string.navigation_drawer_open, R.string.navigation_drawer_close) {
            @Override
            public void onDrawerOpened(View drawerView) {
                super.onDrawerOpened(drawerView);
                DeviceComponents.hideKeyboard(MainActivity.this);
            }
        };
        drawer.addDrawerListener(toggle);
        toggle.syncState();

        navigationView = findViewById(R.id.nav_view);
        navigationView.setNavigationItemSelectedListener(this);
        headerView = navigationView.getHeaderView(0);

        cancelRouteBtn = findViewById(R.id.fbCancelRoute);
        cancelRouteBtn.setOnClickListener(view -> {
            if (routeSocket == null) return;

            BatteryManager bm = (BatteryManager)getSystemService(BATTERY_SERVICE);
            double bateria = bm.getLongProperty(BatteryManager.BATTERY_PROPERTY_CAPACITY);

            routeSocket.sendSingleMessage(
                new BaseMessage("event.route.finish", new EventRouteFinishMessage(bateria, "CANCELADO")),
                Object.class
            ).subscribe(
                res -> {
                    routeSocket.disconnect();

                    runOnUiThread(() -> {
                        Toast.makeText(this, "Rota finalizada!", Toast.LENGTH_LONG).show();
                        cancelRouteBtn.setVisibility(View.INVISIBLE);
                        finish();
                        startActivity(getIntent());
                    });
                },
                err -> {
                    runOnUiThread(() -> {
                        Toast.makeText(this, "Falha ao finalizar rota", Toast.LENGTH_SHORT).show();
                    });
                }
            );
        });

        googleApiClient = new GoogleApiClient.Builder(this)
                .enableAutoManage(this, this)
                .addApi(Places.GEO_DATA_API)
                .addApi(Places.PLACE_DETECTION_API).addApi(Auth.GOOGLE_SIGN_IN_API).build();
        googleApiClient.connect();
        this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);

        TextView txt = headerView.findViewById(R.id.txtUserName);
        CircleImageView userImg = headerView.findViewById(R.id.imgUser);

        txt.setText("Bem vindo, " + UserLogged.get().nome.toString());
        Picasso.get().load(UserLogged.get().imgUrl.toString()).into(userImg);

        getLocationPermission();
        mapSearchText = (AutoCompleteTextView) findViewById(R.id.txtSearch);
    }

    @Override
    public void onBackPressed() {
        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        if (drawer.isDrawerOpen(GravityCompat.START)) {
            drawer.closeDrawer(GravityCompat.START);
        } else {
            super.onBackPressed();
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }



    @SuppressWarnings("StatementWithEmptyBody")
    @Override
    public boolean onNavigationItemSelected(MenuItem item) {
        ActivitiesComponents activitiesComponents = new ActivitiesComponents(MainActivity.this);
        LogoutComponents logoutComponents = new LogoutComponents(MainActivity.this);

        switch (item.getItemId()) {

            case R.id.friends:
                startActivity(activitiesComponents.callScreen(this, FriendsActivity.class));
                break;
            case R.id.groups:
                startActivity(activitiesComponents.callScreen(this, GroupsActivity.class));
                break;
            case R.id.notifications:
                startActivity(activitiesComponents.callScreen(this, NotificationsActivity.class));
                break;
            case R.id.about:
                startActivity(activitiesComponents.callScreen(this, AboutActivity.class)); //ATT escrever pagina sobre
                return true;
            case R.id.exit:
                logoutComponents.performLogout(googleApiClient, CURRENT_TAG);
                return true;
            default:
                break;
        }
        drawer.closeDrawers();
        item.setChecked(false);
        return true;

    }

    @Override
    public void onMapReady(GoogleMap googleMap) {
        if (mapGeoApiContext == null) {
            mapGeoApiContext = new GeoApiContext.Builder().apiKey(getString(R.string.google_maps_key)).build();
        }

        mMap = googleMap;
        cameraComponents = new CameraComponents(mMap, mapMarker, MainActivity.this, this);
        deviceComponents = new DeviceComponents(MainActivity.this, cameraComponents);
        mapComponents = new MapComponents(mMap, mapMarker, MainActivity.this, this, cameraComponents, googleApiClient, MainActivity.this, deviceComponents);
        routeComponents = new RouteComponents(mMap, mapMarker, MainActivity.this, mapGeoApiContext, deviceComponents);

        if (mapPermissionGranted) {
            deviceComponents.getDeviceLocation(mapPermissionGranted);
            if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
                return;
            }
            mMap.setMyLocationEnabled(true);
            mMap.getUiSettings().setMyLocationButtonEnabled(false);
        }

        mMap.setOnMapClickListener((point) -> {
            DeviceComponents.hideKeyboard(MainActivity.this);
            MarkerOptions pos = new MarkerOptions().position(point);
//            mMap.clear();
            mapPlace = mapComponents.searchLocationByLatLng(point, TAG);
            cameraComponents.moveCamera(point, DEFAULT_ZOOM, mapPlace);
        });
        socket.sendSingleMessage(
            new BaseMessage("event.alert.get", new Object()),
            EventAlertGetResult.class
        ).subscribe(
            (res) -> {
                // Result contem os objetos da classe de result
                runOnUiThread(() -> {
                    ArrayList<Alert> result = ((EventAlertGetResult) res.result).res;
                    for (Alert alert : result) {
                        mapComponents.addMapMarkers(MainActivity.this, alert);
                    }
                });
            },
            (err) -> {
                System.out.println("Errou");
                System.out.println(err);
            }
        );

        alertAdd = new BroadcastEvent("alert.add", Alert.class);
        alertAdd.listen()
            .subscribe(
                (res) -> {
                    if (!alertAdd.getReceiverKey().equals(res.broadcastReceiver)) return;
                    Alert result = (Alert) res.result;

                    // Result contem os objetos da classe de result
                    runOnUiThread(() -> {
                        mapComponents.addMapMarkers(MainActivity.this, result);
                    });
                },
                (err) -> {
                    System.out.println("Errou");
                    System.out.println(err);
                });

        routeInvites = new BroadcastEvent("route.invites", Convite.class);
        routeInvites.listen()
            .subscribe(
                (res) -> {
                    if (!routeInvites.getReceiverKey().equals(res.broadcastReceiver)) return;
                    Convite convite = (Convite) res.result;

                    runOnUiThread(() -> {
                        new AlertDialog.Builder(this)
                            .setMessage(convite.usuario.nome + " te convidou para assistir seu percurso")
                            .setCancelable(true)
                            .setPositiveButton("Aceitar", (dialog, id) -> {
                                BroadcastEvent bd = new BroadcastEvent("route.connected", Trajeto.class);
                                bd.listen()
                                    .subscribe(
                                    rotaRes -> {
                                        if (!bd.getReceiverKey().equals(rotaRes.broadcastReceiver)) return;
                                        Trajeto trajeto = (Trajeto) rotaRes.result;

                                        if (!trajeto.uuid.equals(convite.trajetoUuid)) return;

                                        RouteEventsListener ev = new RouteEventsListener(trajeto, mapComponents);
                                        ev.subscribeAll()
                                            .observeOn(Schedulers.newThread())
                                            .subscribe(
                                                suc -> {
                                                    runOnUiThread(() -> {
                                                        routeEvents.add(ev);
                                                        routeComponents.displayRoute(trajeto);

                                                        if (trajeto.lastLocation != null) {
                                                            ev.setPersonMarker(
                                                                    mapComponents.updateUserLocation(trajeto.criador, trajeto.lastLocation, ev.getPersonMarker())
                                                            );
                                                        }
                                                    });
                                                }, System.out::println
                                            );
                                    },
                                    err -> {
                                        System.out.println("Erro recebendo o evento de conectado do trajeto");
                                    }
                                );

                                socket.sendSingleMessage(
                                    new BaseMessage("event.invite.respond",
                                        new EventInviteRespondMessage(true, UserLogged.get().socialId, convite.trajetoUuid)
                                    ), Object.class
                                ).subscribe(
                                    System.out::println, System.out::println
                                );

                                new SocketConnection(convite.trajetoUuid, UserLogged.get().socialId)
                                        .connect();
                            })
                            .setNegativeButton("Recusar", (d, id) -> {
                                socket.sendSingleMessage(
                                    new BaseMessage("event.invite.respond",
                                        new EventInviteRespondMessage(false, UserLogged.get().socialId, convite.trajetoUuid)
                                    ), Object.class
                                ).subscribe(
                                    System.out::println, System.out::println
                                );
                            })
                            .show();
                    });
                },
                (err) -> {
                    System.out.println("Errou");
                    System.out.println(err);
                });

        mapComponents.initSearch(TAG, mapPermissionGranted, mapSearchText, mGps, mapPlace);

        socket.sendSingleMessage(
                new BaseMessage("event.route.getWatching",
                        new EventRouteGetWatchingMessage(UserLogged.get().socialId)
                ), EventRouteGetWatchingResult.class
        ).subscribe(
            (res) -> {
                List<Trajeto> trajetos = ((EventRouteGetWatchingResult) res.result).res;

                BroadcastEvent bd = new BroadcastEvent("route.connected", Trajeto.class);
                bd.listen()
                    .subscribe(
                        rotaRes -> {
                        if (!bd.getReceiverKey().equals(rotaRes.broadcastReceiver)) return;
                        Trajeto trajeto = (Trajeto) rotaRes.result;

                        boolean found = false;

                        for (Trajeto t : trajetos) {
                            if (t.uuid.equals(trajeto.uuid)) found = true;
                        }

                        if (!found) return;

                        RouteEventsListener ev = new RouteEventsListener(trajeto, mapComponents);
                        ev.subscribeAll()
                            .observeOn(Schedulers.newThread())
                            .subscribe(
                                suc -> {
                                    runOnUiThread(() -> {
                                        routeEvents.add(ev);
                                        routeComponents.displayRoute(trajeto);

                                        if (trajeto.lastLocation != null) {
                                            ev.setPersonMarker(
                                                mapComponents.updateUserLocation(trajeto.criador, trajeto.lastLocation, ev.getPersonMarker())
                                            );
                                        }
                                    });
                                }, System.out::println
                            );
                    },
                    err -> {
                        System.out.println("Erro recebendo o evento de conectado do trajeto");
                    }
                );

                for (Trajeto trajeto : trajetos) {
                    new SocketConnection(trajeto.uuid, UserLogged.get().socialId)
                            .connect();
                }
            },
            (err) -> {
                System.out.println(err);
            }
        );

        socket.sendSingleMessage(
            new BaseMessage("event.route.getMyOpenRoute",
                new EventRouteGetWatchingMessage(UserLogged.get().socialId)
            ), Trajeto.class
        ).subscribe(
            (res) -> {
                Trajeto trj = (Trajeto) res.result;

                BroadcastEvent bd = new BroadcastEvent("route.connected", Trajeto.class);
                bd.listen()
                    .subscribe(
                    rotaRes -> {
                        if (!bd.getReceiverKey().equals(rotaRes.broadcastReceiver)) return;

                        Trajeto trajeto = (Trajeto) rotaRes.result;

                        routeSocket.setRoute(trajeto);

                        RouteEventsListener ev = new RouteEventsListener(trajeto, mapComponents);
                        ev.subscribeAll()
                            .observeOn(Schedulers.newThread())
                            .subscribe(
                                suc -> {
                                    runOnUiThread(() -> {

                                        routeEvents.add(ev);
                                        routeComponents.displayRoute(trajeto);
                                        cancelRouteBtn.setVisibility(View.VISIBLE);

                                        if (trajeto.lastLocation != null) {
                                            ev.setPersonMarker(
                                                mapComponents.updateUserLocation(trajeto.criador, trajeto.lastLocation, ev.getPersonMarker())
                                            );
                                        }
                                    });
                                }, System.out::println
                            );
                    },
                    err -> {
                        System.out.println("Erro recebendo o evento de conectado do trajeto");
                    }
                );

                routeSocket = new SocketConnection(trj.uuid, UserLogged.get().socialId);
                routeSocket.connect();
            },
            (err) -> {
                System.out.println(err);
            }
        );

        routeFinish = new BroadcastEvent("route.finish", Object.class);
        routeFinish.listen()
            .observeOn(Schedulers.newThread())
            .subscribe(
                res -> {
                    if (!routeFinish.getReceiverKey().equals(res.broadcastReceiver)) return;

                    System.out.println("Rota finalizada -> " + res.key);
                    SocketConnection routeConn = SocketConnection.findRouteConnection(res.key);

                    if (routeConn != null)
                        routeConn.disconnect();

                    runOnUiThread(() -> {
                        Toast.makeText(this, "Rota finalizada!", Toast.LENGTH_LONG).show();
                        finish();
                        startActivity(getIntent());
                    });
                },
                err -> {
                    System.out.println("Erro finalizando Rota");
                    System.out.println("err");
                }
            );

        locManager = (LocationManager) this.getSystemService(Context.LOCATION_SERVICE);
        locListener = new LocationListener() {
            @Override
            public void onStatusChanged(String provider, int status,
                                        Bundle extras) {
            }
            @Override
            public void onProviderEnabled(String provider) {
            }
            @Override
            public void onProviderDisabled(String provider) {
            }
            @Override
            public void onLocationChanged(Location location) {
                if (routeSocket == null) {
                    return;
                }

                BatteryManager bm = (BatteryManager)getSystemService(BATTERY_SERVICE);

                boolean isOnPath = verifyUserOnPath(new LatLng(location.getLatitude(), location.getLongitude()));

                Date currentTime = Calendar.getInstance().getTime();

                EventVerifyUserOnRouteMessage verify = new EventVerifyUserOnRouteMessage(
                    currentTime,
                    isOnPath,
                    routeSocket.getTrajetoUuid(),
                    new Coordenada(location.getLatitude(), location.getLongitude())
                );

                routeSocket.sendSingleMessage(
                    new BaseMessage("event.route.verifyOnRoute", verify),
                    Object.class
                ).subscribe(
                    System.out::println,
                    System.out::println
                );

                routeSocket.sendSingleMessage(
                    new BaseMessage("broadcast.my.coordinates",
                        new EventBroadcastCoordinatesMessage(
                            new Coordenada(location.getLatitude(), location.getLongitude()),
                            bm.getLongProperty(BatteryManager.BATTERY_PROPERTY_CAPACITY)
                        )
                    ),
                    Object.class
                ).subscribe(
                    (res) -> {
                        System.out.println("Location changed -> Lat: " + location.getLatitude() + " Lon: " + location.getLongitude());
                    },
                    (err) -> {
                        System.out.println("Errou");
                        System.out.println(err);
                    }
                );
            }
        };
        locManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 1000, 1, locListener);
    }

    private boolean verifyUserOnPath(LatLng location) {
        if (routeSocket == null) return false;
        if (routeSocket.getTrajeto() == null) return false;
        if (routeSocket.getTrajeto().pontos == null) return false;
        if (routeSocket.getTrajeto().pontos.getPontosList() == null) return false;

        for (List<LatLng> polyline : routeSocket.getTrajeto().pontos.getPontosList()) {
            if (PolyUtil.isLocationOnPath(location, polyline, true, 70)) return true;
        }

        return false;
    }

    @Override
    public void onConnectionFailed(@NonNull ConnectionResult connectionResult) {
        Toast.makeText(this, "Falha na conexão", Toast.LENGTH_LONG);
    }

    private void getLocationPermission() {
        String[] permissions = {Manifest.permission.ACCESS_FINE_LOCATION,
                Manifest.permission.ACCESS_COARSE_LOCATION};
        if (ContextCompat.checkSelfPermission(this.getApplicationContext(),
                FINE_LOCATION) == PackageManager.PERMISSION_GRANTED) {
            if (ContextCompat.checkSelfPermission(this.getApplicationContext(),
                    COURSE_LOCATION) == PackageManager.PERMISSION_GRANTED) {
                mapPermissionGranted = true;
                SupportMapFragment mapFragment = (SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map);
                MapComponents.initMap(MainActivity.this, mapFragment);
            } else {
                ActivityCompat.requestPermissions(this, permissions, LOCATION_PERMISSION_REQUEST_CODE);
            }
        } else {
            ActivityCompat.requestPermissions(this, permissions, LOCATION_PERMISSION_REQUEST_CODE);
        }
    }

    @Override
    public void onMyLocationChange(Location location) {
        //ATT implementar socket para salvar location
        System.out.println("LOCAL ----------");
        System.out.println(location);
    }

    /**
     * Seta o tipo do trajeto para a requisição de nova rota
     *
     * @param descricao
     * @param modo
     */
    public static void setTipoTrajeto(String descricao, String modo) {
        tipoTrajeto = new TipoTrajeto(descricao, modo);
    }

    /**
     * Recebe o tipo do trajeto
     *
     * @return TipoTrajeto
     */
    public static TipoTrajeto getTipoTrajeto() {
        return tipoTrajeto;
    }


    public void changeBtnVisibility(int i) {
        Button btn = (Button) findViewById(R.id.btnStartRoutes);
        btn.setVisibility(i);
    }

    public void onCreateRoutes(View view) {
        if (routeSocket != null) {
            Toast.makeText(this, "Você ja está em uma rota", Toast.LENGTH_SHORT).show();
            return;
        }
        friends = new ArrayList<>();

        socket.sendSingleMessage(
                new BaseMessage("event.friends.get", new EventFriendGetMessage(UserLogged.get().socialId, null)),
                EventFriendGetResult.class
        ).subscribe(
                (res) -> {
                    friends = ((EventFriendGetResult) res.result).res;
                },
                (err) -> {
                    System.out.println("Errou");
                    System.out.println(err);
                }
        );

        socket.sendSingleMessage(
                new BaseMessage("event.group.get", new EventGroupGetMessage(UserLogged.get().socialId)),
                EventGroupGetResult.class
        ).subscribe(
                (res) -> {
                    groups = ((EventGroupGetResult) res.result).res;
                },
                (err) -> {
                    System.out.println("Errou");
                    System.out.println(err);
                }
        );

        view.setVisibility(View.INVISIBLE);
        findViewById(R.id.btnStartTrip).setVisibility(View.VISIBLE);
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setTitle("Metodo de Transporte");
        builder.setItems(tipos, new DialogInterface.OnClickListener() {
            TravelMode mode;

            @Override
            public void onClick(DialogInterface dialog, int item) {
                switch (item) {
                    case 0:
                        System.out.println("Dirigindo");
                        mode = TravelMode.DRIVING;
                        break;
                    case 1:
                        System.out.println("Bicicleta");

                        mode = TravelMode.BICYCLING;
                        break;
                    case 2:
                        System.out.println("Onibus");
                        mode = TravelMode.TRANSIT;
                        break;
                    case 3:
                        System.out.println("Andando");
                        mode = TravelMode.WALKING;
                        break;
                }

                routeComponents.calculateRoute(new Coordenada(cameraComponents.getMapMarker()), mode);

            }
        });
        builder.show();

    }

    public void onStarTrip(View view) {
        findViewById(R.id.btnStartTrip).setVisibility(View.INVISIBLE);
        List<Integer> selectedIds = new ArrayList<>();

        ArrayList<String> friendString = new ArrayList<>();
        for (int i = 0; i < friends.size(); i++) {
            friendString.add(friends.get(i).nome);
        }
        ArrayList<String> groupString = new ArrayList<>();
        if (groups != null) {
            for (int i = 0; i < groups.size(); i++) {
                groupString.add("Grupo: " + groups.get(i).nome);
            }
        }

        groupString.addAll(friendString);
        String[] itemsStringArr = groupString.toArray(new String[0]);

        boolean[] checkItems  = new boolean[groupString.size()];
        Arrays.fill(checkItems, Boolean.FALSE);

        AlertDialog.Builder mBuilder = new AlertDialog.Builder(this);
        mBuilder.setTitle("Selecione os Amigos para observar sua rota");
        mBuilder.setMultiChoiceItems(itemsStringArr, checkItems,
            (dialogInterface, i, b) -> {
                if (selectedIds.contains(i)) return;

                selectedIds.add(i);
            }
        );
        mBuilder.setPositiveButton("Confirmar", (dialogInterface, i) -> {
            ArrayList<User> userSelect = new ArrayList<>();
            for(int j = 0; j < selectedIds.size(); j++){
                int size = 0;

                if (groups != null) size = groups.size();

                if (j >= size) {
                    userSelect.add(friends.get(j - size));
                } else {
                    ArrayList<User> usu = new ArrayList<>();

                    for (String gr : groups.get(j).membros) {
                        usu.add(new User(gr));
                    }

                    userSelect.addAll(usu);
                }
            }
            Trajeto trajeto = new Trajeto();
            trajeto.setPontos(routeComponents.setMySelectedRoute());
            trajeto.setCriador(UserLogged.get());
            BatteryManager bm = (BatteryManager)getSystemService(BATTERY_SERVICE);
            trajeto.setBateria(bm.getLongProperty(BatteryManager.BATTERY_PROPERTY_CAPACITY));
            trajeto.setConvidados(userSelect);

            socket.sendSingleMessage(
                new BaseMessage("event.route.start", trajeto),
                Trajeto.class
            ).subscribe(
                res -> {
                    Trajeto trj = (Trajeto) res.result;

                    routeSocket = new SocketConnection(trj.uuid, UserLogged.get().socialId);
                    routeSocket.connect();
                    routeSocket.setRoute(trajeto);
                    runOnUiThread(() -> {
                        cancelRouteBtn.setVisibility(View.VISIBLE);
                    });
                },
                err -> {
                    System.out.println("Não foi possível criar uma nova rota -> " + err);
                }
            );
        }).setNegativeButton("Cancelar", null);
        mBuilder.show();
    }

    public void showAlertPopUp(View view) {
        TextView txtClose;
        EditText editDate, editTime;
        Button saveButton;
        dialog = new Dialog(this);
        dialog.setContentView(R.layout.report_alert_popup);
        saveButton = (Button) dialog.findViewById(R.id.saveButton);
        txtClose = (TextView) dialog.findViewById(R.id.closeButton);
        txtClose.setOnClickListener(v -> dialog.dismiss());
        dialog.show();
        carouselPicker1 = (CarouselPicker) dialog.findViewById(R.id.alertType);
        editDate = (EditText) dialog.findViewById(R.id.editDate);
        editTime = (EditText) dialog.findViewById(R.id.editTime);

        List<CarouselPicker.PickerItem> itemsImages = new ArrayList<>();
        itemsImages.add(new CarouselPicker.DrawableItem(R.drawable.ic_robbery));
        itemsImages.add(new CarouselPicker.DrawableItem(R.drawable.ic_theft));
        itemsImages.add(new CarouselPicker.DrawableItem(R.drawable.ic_harassment));
        itemsImages.add(new CarouselPicker.DrawableItem(R.drawable.ic_kidnap));
        itemsImages.add(new CarouselPicker.DrawableItem(R.drawable.ic_animal));
        itemsImages.add(new CarouselPicker.DrawableItem(R.drawable.ic_luminosity));
        itemsImages.add(new CarouselPicker.DrawableItem(R.drawable.ic_others));
        CarouselPicker.CarouselViewAdapter imageAdapter = new CarouselPicker.CarouselViewAdapter(this, itemsImages, 0);
        carouselPicker1.setAdapter(imageAdapter);
        editDate.addTextChangedListener(MaskEditUtil.mask(editDate, MaskEditUtil.FORMAT_DATE));
        editTime.addTextChangedListener(MaskEditUtil.mask(editTime, MaskEditUtil.FORMAT_HOUR));
        saveButton.setOnClickListener(v -> {
            EditText description, date, time;
            String descValue, dateValue, timeValue;
            Coordenada coordenada;
            try {
                description = (EditText) dialog.findViewById(R.id.alertDescription);
                date = (EditText) dialog.findViewById(R.id.editDate);
                time = (EditText) dialog.findViewById(R.id.editTime);
                descValue = String.valueOf(description.getText().toString());
                dateValue = String.valueOf(date.getText().toString());
                timeValue = String.valueOf(time.getText().toString());
                dateValue = ConvertDateFormatUtil.convertDMYToMDY(dateValue);
                coordenada = new Coordenada(mapPlace.getLatLng().latitude, mapPlace.getLatLng().longitude);
                if (!ValidateTimeUtil.validateDateTime(dateValue, timeValue)) {
                    Toast.makeText(MainActivity.this, "Data ou Horário inválidos!", Toast.LENGTH_SHORT).show();
                    return;
                }
                    EventAlertAddMessage eventAlertAddMessage = new EventAlertAddMessage(
                        carouselPicker1.getCurrentItem() + 1, descValue, coordenada, dateValue + " " + timeValue, UserLogged.get().socialId);

                socket.sendSingleMessage(
                        new BaseMessage("event.alert.add", eventAlertAddMessage),
                        Alert.class
                ).subscribe(
                        (res) -> {
                            // res
                        },
                        (err) -> {
                            System.out.println("Errou");
                            System.out.println(err);
                        }
                );

                Toast.makeText(MainActivity.this, "Acontecimento salvo com sucesso!", Toast.LENGTH_SHORT).show();
                dialog.dismiss();
            } catch (Exception e) {
                Toast.makeText(dialog.getContext(), "Preencha todos os dados e selecione um local!", Toast.LENGTH_SHORT).show();
            }

        });
    }

    public void onDestroy() {
        super.onDestroy();

        SocketConnection.dismissAll();
    }

    public void onCancelRoute(View view) {
        
    }
}
