package br.com.tcc.safeson.safeson.activity;

import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Toast;

import com.baoyz.swipemenulistview.SwipeMenu;
import com.baoyz.swipemenulistview.SwipeMenuCreator;
import com.baoyz.swipemenulistview.SwipeMenuItem;
import com.baoyz.swipemenulistview.SwipeMenuListView;
import com.google.android.gms.maps.model.LatLng;

import java.util.ArrayList;

import br.com.tcc.safeson.safeson.R;
import br.com.tcc.safeson.safeson.actions.BaseMessage;
import br.com.tcc.safeson.safeson.actions.EventFriends.EventFriendGetMessage;
import br.com.tcc.safeson.safeson.actions.EventFriends.EventFriendGetResult;
import br.com.tcc.safeson.safeson.adapter.FriendListCell;
import br.com.tcc.safeson.safeson.dialog.FriendNewDialog;
import br.com.tcc.safeson.safeson.login.UserLogged;
import br.com.tcc.safeson.safeson.models.User;
import br.com.tcc.safeson.safeson.socket.SocketConnection;

public class FriendsActivity extends AppCompatActivity implements SwipeMenuListView.OnMenuItemClickListener {

    private static final String TAG = "FriendsAc";
    SwipeMenuListView lwFriends;
    ArrayList<User> friends;
    FriendListCell adapter;


    private SocketConnection socket = SocketConnection.main;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_friends);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        lwFriends = (SwipeMenuListView) findViewById(R.id.lsFriends);
        friends = new ArrayList<>();
        adapter = new FriendListCell(this, friends, 1);
        lwFriends.setOnMenuItemClickListener(this);
        lwFriends.setAdapter(adapter);

        loadFriends();


        SwipeMenuCreator creator = menu -> {
            SwipeMenuItem deleteItem = new SwipeMenuItem( getApplicationContext());
            deleteItem.setBackground(new ColorDrawable(Color.rgb(0xF9,  0x3F, 0x25)));
            deleteItem.setWidth(170);
            deleteItem.setIcon(R.drawable.ic_delete);
            menu.addMenuItem(deleteItem);
        };
        lwFriends.setMenuCreator(creator);

    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // handle arrow click here
        if (item.getItemId() == android.R.id.home) {
            finish();
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public boolean onMenuItemClick(int position, SwipeMenu menu, int index) {
        switch (index) {
            case 0:
                EventFriendGetMessage msg = new EventFriendGetMessage(UserLogged.get().socialId, friends.get(position).socialId);
                socket.sendSingleMessage(
                        new BaseMessage("event.friends.remove", msg),
                        User.class
                ).subscribe(
                        (res) -> {
                            System.out.println("Ok exclude: ");
                            loadFriends();
                        },
                        (err) -> {
                            Toast.makeText(this, "Erro ao deletar Usuário", Toast.LENGTH_SHORT).show();
                            System.out.println("Errou");
                            System.out.println(err);
                        }
                );
                break;
        }
        // false : close the menu; true : not close the menu
        return false;
    }

    @Override
    protected void onResume() {
        loadFriends();
        super.onResume();
    }

    public void loadFriends(){
        EventFriendGetMessage msg = new EventFriendGetMessage(UserLogged.get().socialId, null);

        socket.sendSingleMessage(
                new BaseMessage("event.friends.get", msg),
                EventFriendGetResult.class
        ).subscribe(
                (res) -> {
                    friends = ((EventFriendGetResult) res.result).res;
                    runOnUiThread(()-> {
                        updateAdapter(adapter, friends);
                        adapter.notifyDataSetChanged();
                    });
                },
                (err) -> {
                    runOnUiThread(()-> {
                        updateAdapter(adapter, friends);
                        adapter.notifyDataSetChanged();
                    });
                    System.out.println("Errou");
                    System.out.println(err);
                }
        );


    }
    public void updateAdapter(ArrayAdapter arrayAdapter, ArrayList<User> listOfObject){
        arrayAdapter.clear();
        for (User object : listOfObject){
            arrayAdapter.add(object);
        }
    }
    public void onAddNewFriend(View view) {
        FriendNewDialog dialog = new FriendNewDialog();
        dialog.show(getSupportFragmentManager(), "Adicionar Amigo");
    }
}
