package br.com.tcc.safeson.safeson.activity;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Toast;

import com.baoyz.swipemenulistview.SwipeMenu;
import com.baoyz.swipemenulistview.SwipeMenuCreator;
import com.baoyz.swipemenulistview.SwipeMenuItem;
import com.baoyz.swipemenulistview.SwipeMenuListView;

import java.io.Serializable;
import java.util.ArrayList;

import br.com.tcc.safeson.safeson.MainActivity;
import br.com.tcc.safeson.safeson.R;
import br.com.tcc.safeson.safeson.actions.BaseMessage;
import br.com.tcc.safeson.safeson.actions.EventGroup.EventGroupGetMessage;
import br.com.tcc.safeson.safeson.actions.EventGroup.EventGroupGetResult;
import br.com.tcc.safeson.safeson.actions.EventGroup.EventGroupRemoveMessage;
import br.com.tcc.safeson.safeson.components.ActivitiesComponents;
import br.com.tcc.safeson.safeson.login.UserLogged;
import br.com.tcc.safeson.safeson.models.Grupo;
import br.com.tcc.safeson.safeson.socket.SocketConnection;

public class GroupsActivity extends AppCompatActivity {
    SwipeMenuListView lwGroups;
    ArrayList<Grupo> grupos;
    FloatingActionButton fAddButton;

    SocketConnection socket = SocketConnection.main;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_groups);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setDisplayShowHomeEnabled(true);
        lwGroups = (SwipeMenuListView) findViewById(R.id.lsGrupos);
        ActivitiesComponents activitiesComponents = new ActivitiesComponents(GroupsActivity.this);

        fAddButton = findViewById(R.id.addGroup);
        fAddButton.setOnClickListener((view) -> {
            Intent intent = new Intent(this, GroupActivity.class);
            intent.putExtra("grupo", (Serializable) null);
            startActivity(intent);
            finish();
        });

        socket.sendSingleMessage(
            new BaseMessage("event.group.get",
                new EventGroupGetMessage(UserLogged.get().socialId)),
                EventGroupGetResult.class
        ).subscribe(
            res -> {
                grupos = ((EventGroupGetResult) res.result).res;

                ArrayList<String> grps = new ArrayList<>();

                for (Grupo g : grupos) {
                    grps.add(g.nome);
                }

                runOnUiThread(() -> {
                    ArrayAdapter<String> adapter = new ArrayAdapter<>(this, android.R.layout.simple_list_item_1, grps);
                    lwGroups.setAdapter(adapter);
                    SwipeMenuCreator creator = menu -> {
                        SwipeMenuItem deleteItem = new SwipeMenuItem( getApplicationContext());
                        deleteItem.setBackground(new ColorDrawable(Color.rgb(0xF9,  0x3F, 0x25)));
                        deleteItem.setWidth(170);
                        deleteItem.setIcon(R.drawable.ic_delete);
                        menu.addMenuItem(deleteItem);
                    };
                    lwGroups.setMenuCreator(creator);
                    Context current = this;

                    lwGroups.setOnMenuItemClickListener((position, menu, index) -> {
                        socket.sendSingleMessage(
                            new BaseMessage("event.group.remove",
                                new EventGroupRemoveMessage(grupos.get(position).id)),
                            Object.class
                        ).subscribe(
                            exc -> {
                                runOnUiThread(() -> {
                                    Toast.makeText(current, "Grupo excluido", Toast.LENGTH_SHORT).show();
                                    finish();
                                    startActivity(getIntent());
                                });
                            },
                            err -> {
                                runOnUiThread(() -> {
                                    Toast.makeText(current, "Falha ao excluir grupo", Toast.LENGTH_SHORT).show();
                                });
                            }
                        );
                        return false;
                    });

                    lwGroups.setOnItemClickListener((adapterView, view, i, l) -> {
                        Intent intent = new Intent(current, GroupActivity.class);
                        intent.putExtra("grupo", grupos.get(i));
                        startActivity(intent);
                    });
                });
            },
            err -> {
                System.out.println("Erro recebendo os grupos");
            }
        );

    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // handle arrow click here
        if (item.getItemId() == android.R.id.home) {
            finish();
        }
        return super.onOptionsItemSelected(item);
    }

    public void onAddNewGroup(View view) {
    }
}
