package br.com.tcc.safeson.safeson.activity;

import android.annotation.SuppressLint;
import android.content.Context;
import android.location.Location;
import android.os.CountDownTimer;
import android.os.Vibrator;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.os.Handler;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.tasks.Task;

import java.net.Socket;

import br.com.tcc.safeson.safeson.R;
import br.com.tcc.safeson.safeson.actions.BaseMessage;
import br.com.tcc.safeson.safeson.actions.EventPanic.EventPanicAddMessage;
import br.com.tcc.safeson.safeson.login.UserLogged;
import br.com.tcc.safeson.safeson.models.Coordenada;
import br.com.tcc.safeson.safeson.socket.SocketConnection;
import butterknife.BindView;

public class PanicoActivity extends AppCompatActivity {

    TextView timerTxt;
    Vibrator v;

    SocketConnection routeSocket = SocketConnection.myRouteConnection();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.activity_panico);

        ActionBar actionBar = getSupportActionBar();
        actionBar.hide();
        timerTxt = (TextView) findViewById(R.id.txtTimer);
        final int time = 6000;
        v = (Vibrator) getSystemService(Context.VIBRATOR_SERVICE);
        v.vibrate(time);
        Context context = getApplicationContext();

        new CountDownTimer(time, 1000) // Wait 5 secs, tick every 1 sec
        {
            @Override
            public final void onTick(final long millisUntilFinished)
            {
                timerTxt.setText("" + (int) (millisUntilFinished * .001f));
            }
            @Override
            public final void onFinish() {
                timerTxt.setText("GO!");

                FusedLocationProviderClient mapFusedLocationProviderClient =
                        LocationServices.getFusedLocationProviderClient(context);

                Task location = mapFusedLocationProviderClient.getLastLocation();
                location.addOnCompleteListener(task -> {
                    if (task.isSuccessful()) {
                        Location currentLocation = (Location) task.getResult();

                        Coordenada coords = new Coordenada(
                            currentLocation.getLatitude(), currentLocation.getLongitude()
                        );

                        // enviar msg de panico
                        routeSocket.sendSingleMessage(
                            new BaseMessage("event.panic.add",
                                new EventPanicAddMessage(UserLogged.get().socialId, routeSocket.getTrajetoUuid(), coords)
                            ), Object.class
                        ).subscribe(
                            System.out::println,
                            System.out::println
                        );
                    } else {
                        Toast.makeText(context, "Não foi possível receber o local atual", Toast.LENGTH_SHORT).show();
                    }
                });


                finish();
            }
        }.start();
    }

    public void onCancel(View view) {
        finish();
        v.cancel();
    }
}
