package br.com.tcc.safeson.safeson.adapter;

import android.app.Activity;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.TextView;

import com.squareup.picasso.Picasso;

import java.util.ArrayList;

import br.com.tcc.safeson.safeson.R;
import br.com.tcc.safeson.safeson.models.User;
import de.hdodenhof.circleimageview.CircleImageView;

public class FriendListCell extends ArrayAdapter<User> {
    private final ArrayList<User> friends;
    private ArrayList<User> selecionados = new ArrayList<>();
    private final Activity context;
    private int type;

    public FriendListCell(Activity context, ArrayList<User> friends, int type){
        super(context, R.layout.friend_list_cell, friends);
        this.friends = friends;
        this.context = context;
        this.type = type;
    }

    public FriendListCell(Activity context, ArrayList<User> friends, ArrayList<User> selecionados, int type){
        super(context, R.layout.friend_list_cell, friends);
        this.friends = friends;
        this.context = context;
        this.selecionados = selecionados;
        this.type = type;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        LayoutInflater inflater = context.getLayoutInflater();
        View rowView = inflater.inflate(R.layout.friend_list_cell, null, true);
        TextView name = (TextView) rowView.findViewById(R.id.txtFriendName);
        TextView email = (TextView) rowView.findViewById(R.id.txtFriendEmail);
        CircleImageView img = rowView.findViewById(R.id.imgUser);
        name.setText(friends.get(position).nome);
        email.setText(friends.get(position).email);
        if(type == 2 ){
            rowView.findViewById(R.id.checkbox).setVisibility(View.VISIBLE);

            // Seta os usuários que estão selecionados
            if (!this.selecionados.isEmpty()) {
                for (User selecionado : this.selecionados) {
                    if (friends.get(position).socialId.equals(selecionado.socialId)) {
                        ((CheckBox) rowView.findViewById(R.id.checkbox)).setChecked(true);
                    }
                }
            }
        }
        if (friends.get(position).imgUrl != null)
            Picasso.get().load(friends.get(position).imgUrl.toString()).into(img);

        return rowView;
    }

}
