package br.com.tcc.safeson.safeson.adapter;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.TextView;

import java.text.SimpleDateFormat;
import java.util.ArrayList;

import br.com.tcc.safeson.safeson.R;
import br.com.tcc.safeson.safeson.models.Invite;

public class InviteListCell extends ArrayAdapter<Invite> {
    private ArrayList<Invite> invites;
    private Activity activity;
    private BtnClickListener aceitarListener = null;
    private BtnClickListener recusarListener = null;

    public InviteListCell(Activity activity, ArrayList<Invite> invites, BtnClickListener aceitar, BtnClickListener recusar){
        super(activity, R.layout.invite_new_list_cell, invites);
        this.activity = activity;
        this.invites = invites;
        this.aceitarListener = aceitar;
        this.recusarListener = recusar;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        LayoutInflater inflater = this.activity.getLayoutInflater();
        View rowView = inflater.inflate(R.layout.invite_new_list_cell, null, true);

        TextView message = (TextView) rowView.findViewById(R.id.message);
        TextView time = (TextView) rowView.findViewById(R.id.time);
        Button aceitar = (Button) rowView.findViewById(R.id.aceitarBtn);
        Button recusar = (Button) rowView.findViewById(R.id.recusarBtn);
        aceitar.setTag(position); //For passing the list item index
        aceitar.setOnClickListener(v -> {
            if(aceitarListener != null)
                aceitarListener.onBtnClick((Integer) v.getTag());
        });
        recusar.setTag(position); //For passing the list item index
        recusar.setOnClickListener(v -> {
            if(recusarListener != null)
                recusarListener.onBtnClick((Integer) v.getTag());
        });

        message.setText(this.invites.get(position).usuario.nome);
        time.setText(new SimpleDateFormat("dd/MM/yyyy hh:mm:ss").format(this.invites.get(position).data_enviado));

        return rowView;
    }

}
