package br.com.tcc.safeson.safeson.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;

import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.model.Marker;

import br.com.tcc.safeson.safeson.R;

public class MapInfoWindowAdapter implements GoogleMap.InfoWindowAdapter {
    private final View mapWindow;
    private Context context;

    public MapInfoWindowAdapter(Context context) {
        this.context = context;
        mapWindow = LayoutInflater.from(context).inflate(R.layout.map_info_window, null);
    }

    private  void setWindowText(Marker marker, View view){
        String title = marker.getTitle();
        TextView txtTitle = (TextView)view.findViewById(R.id.title);
        if (title == null) {
            return;
        }

        if(!title.equals("")){
            txtTitle.setText(title);
        }
        String snippet = marker.getSnippet();
        TextView txtSnippet = (TextView) view.findViewById(R.id.snippet);
        if(!snippet.equals("")){
            txtSnippet.setText(snippet);
        }

    }

    @Override
    public View getInfoWindow(Marker marker) {
        setWindowText(marker, mapWindow);

        return mapWindow;
    }

    @Override
    public View getInfoContents(Marker marker) {
        setWindowText(marker, mapWindow);
        return mapWindow;
    }
}
