package br.com.tcc.safeson.safeson.dialog;

import android.app.Activity;
import android.app.Dialog;
import android.content.DialogInterface;
import android.nfc.Tag;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatDialogFragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import br.com.tcc.safeson.safeson.R;
import br.com.tcc.safeson.safeson.actions.BaseMessage;
import br.com.tcc.safeson.safeson.actions.EventFriends.EventFriendAddMessage;
import br.com.tcc.safeson.safeson.actions.EventFriends.EventFriendGetResult;
import br.com.tcc.safeson.safeson.activity.FriendsActivity;
import br.com.tcc.safeson.safeson.login.UserLogged;
import br.com.tcc.safeson.safeson.models.User;
import br.com.tcc.safeson.safeson.socket.SocketConnection;

public class FriendNewDialog  extends AppCompatDialogFragment{
    private EditText email;


    private SocketConnection socket = SocketConnection.main;


    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());

        LayoutInflater inflater = getActivity().getLayoutInflater();

        View view = inflater.inflate(R.layout.friend_new_dialog, null);


        builder.setView(view)
            .setTitle("Adicionar Amigo").setNegativeButton("Cancelar", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {

            }
        }).setPositiveButton("Adicionar", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialogInterface, int i) {
                email = view.findViewById(R.id.txtNewFriendEmail);
                String socialId = UserLogged.get().socialId;

                EventFriendAddMessage msg = new EventFriendAddMessage(socialId, email.getText().toString());

                FriendsActivity contex =(FriendsActivity) getActivity();

                socket.sendSingleMessage(
                        new BaseMessage("event.friends.add", msg),
                        User.class
                ).subscribe(
                        (res) -> {
                            contex.runOnUiThread(()-> Toast.makeText(contex, "Adcionado com sucesso", Toast.LENGTH_SHORT).show());
                            contex.loadFriends();
                            System.out.println("Ok add: ");
                        },
                        (err) -> {
                            contex.runOnUiThread(()-> Toast.makeText(contex, "Usuário não encontrado", Toast.LENGTH_SHORT).show());
                            System.out.println("Errou");
                            System.out.println(err);
                        }
                );


            }
        });
        return builder.create();
    }
}
