package br.com.tcc.safeson.safeson.models;

import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Polyline;
import com.google.android.gms.maps.model.PolylineOptions;
import com.google.maps.model.DirectionsLeg;
import com.google.maps.model.TravelMode;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class PolylineData implements Serializable {

    private transient ArrayList<Polyline> polylinesList;
    private transient PolylineOptions fullPathData;
    private transient TravelMode mainTravelModeData;
    private transient DirectionsLeg legData;

    private ArrayList<List<LatLng>> pontosList;
    private ArrayList<com.google.maps.model.TravelMode> travelModeData;

    public PolylineData(ArrayList<Polyline> polylines, ArrayList<List<LatLng>> pontosList, DirectionsLeg leg, PolylineOptions polylineOptions, ArrayList<TravelMode> travelMode, TravelMode mainTravelMode) {
        this.polylinesList = polylines;
        this.legData = leg;
        this.fullPathData = polylineOptions;
        this.travelModeData = travelMode;
        this.mainTravelModeData = mainTravelMode;
        this.pontosList = pontosList;
    }

    public ArrayList<List<LatLng>> getPontosList() {
        return pontosList;
    }

    public void setPontosList(ArrayList<List<LatLng>> pontosList) {
        this.pontosList = pontosList;
    }

    public PolylineData() {
    }

    public ArrayList<com.google.maps.model.TravelMode> getTravelMode() {
        return travelModeData;
    }

    public void setTravelMode(ArrayList<com.google.maps.model.TravelMode> travelMode) {
       travelMode = travelMode;
    }

    public TravelMode getMainTravelMode() {
        return mainTravelModeData;
    }

    public PolylineData(ArrayList<Polyline> polylineList) {
        this.polylinesList = polylineList;
    }

    public ArrayList<Polyline> getPolyline() {
        return polylinesList;
    }

    public void setPolyline(ArrayList<Polyline> polyline) {
        this.polylinesList = polyline;
    }

    public DirectionsLeg getLeg() {
        return legData;
    }

    public void setLeg(DirectionsLeg leg) {
        this.legData = leg;
    }

    public PolylineOptions getFullPath() {
        return fullPathData;
    }

    public void setFullPath(PolylineOptions fullPathData) {
        this.fullPathData = fullPathData;
    }



    @Override
    public String toString() {
        return "PolylineData{" +
                "polyline=" + polylinesList.toString() +
                ", leg=" + legData +
                '}';
    }
}
