package br.com.tcc.safeson.safeson.models;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;

public class Trajeto implements Serializable {
    public String dataInicio;
    public String uuid;
    public double bateria;
    public double duracao;
    public boolean finalizado;
    public Coordenada partida;
    public Coordenada destino;
    public TipoTrajeto tipoTrajeto;
    public User criador;
    public PolylineData pontos;
    public ArrayList<User> convidados;
    public Coordenada lastLocation;

    public void setConvidados(ArrayList<User> contatos) {
        this.convidados = contatos;
    }

    public void setPontos(PolylineData pontos) {
        this.pontos = pontos;
        this.duracao = pontos.getLeg().duration.inSeconds;
        this.partida = new Coordenada(pontos.getLeg().startLocation.lat, pontos.getLeg().startLocation.lng);
        this.destino = new Coordenada(pontos.getLeg().endLocation.lat, pontos.getLeg().endLocation.lng);
        this.dataInicio = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss").format(Calendar.getInstance().getTime());
        this.tipoTrajeto = new TipoTrajeto(null, pontos.getMainTravelMode().toString());
    }

    public void setCriador(User criador) {
        this.criador = criador;
    }

    public void setBateria(double bateria) {
        this.bateria = bateria;
    }

    @Override
    public String toString() {
        return "Trajeto{" +
                ", uuid='" + uuid + '\'' +
                '}';
    }
}
